#include <iostream>
#include "m.cpp"

#define N 3

//przyklad
//double tab[N][N]={{1,1,0},{1,5,2},{0,2,10}};
//double tab[N][N]={{1,2,0},{4,5,6},{0,8,2}};
double tab[N][N]={{2,-1,0},{-1,2,-1},{0,-1,2}};
double tabb[2][N]={{0,2,1},{1,1,1}};

int main()
{
	SquareM<double> m(N,2);
	m.SetA((double*)tab);
	m.SetB((double*)tabb);

	//mozna tez sobie wczytac z klawiatury
	//cin >> m;
	cout << "\nWybor czesciowy" << endl;
	cout << m << endl;
	cout << (m.Gauss_partial()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.Results(cout);

	/*cout << "\nWybor pelny" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.Gauss_full()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.Results(cout);

	cout << "\nGauss-Jordan" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.Gauss_Jordan()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.Results(cout);

	cout << "\nLU Doolittla" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.LU1()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.LU(cout);

	cout << "\nLU Crouta" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.LU2()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.LU(cout);

	cout << "\nRozklad dla maciezy trojdiagonalnej" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.D3()? "det!=0":"det=0") <<endl;
	cout << m << endl;
	m.Results(cout);*/

	cout << "\nCholesky-Banachiewicz" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	//cin >> m;
	cout << m << endl;
	cout << (m.CB()? "Ok":"Nie spelnia warunkow") <<endl;
	cout << m << endl;
	m.LU(cout);
/*
	cout << m << endl;;
	m.Gauss_partial();
	cout << m;*/

	//iteracyjne
	int k;
	cout << "Podaj ilosc iteracji: "; cin >> k;

	cout << "\nRichardson" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	m.Richardson(k);
	cout << m;
	m.Results(cout);

	cout << "\nJacobsena" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	m.Jacob(k);
	cout << m;
	m.Results(cout);

	cout << "\nGaussa-Seidla" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	m.GS(k);
	cout << m;
	m.Results(cout);

	cout << "\nSOR" << endl;
	m.SetA((double*)tab);
	m.SetB((double*)tabb);
	m.SOR(k,0.6); //pzykladowy wsp. = 0.6
	cout << m;
	m.Results(cout);
}